## libcompizconfig 0.9.7.0~bzr428

=== CMakeLists.txt ===
project (libcompizconfig)

find_package (Compiz REQUIRED)

set (CMAKE_MODULE_PATH_ORIG ${CMAKE_MODULE_PATH})
set (LIBCOMPIZCONFIG_CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${LIBCOMPIZCONFIGZ_CMAKE_MODULE_PATH})

include (CompizCommon)
include (CompizPackage)
include (CheckLibraryExists)
include (CheckIncludeFile)

set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)

# libcompizconfig package version number
# An odd micro number indicates in-progress development.
# An even micro number indicates a released version.
file (READ ${CMAKE_SOURCE_DIR}/VERSION COMPIZ_RELEASE_VERSION LIMIT 12 OFFSET 0)
string (STRIP ${COMPIZ_RELEASE_VERSION} COMPIZ_RELEASE_VERSION)

set (VERSION ${COMPIZ_RELEASE_VERSION})

set (_libcompizconfig_package_string "LibCompizConfig ${VERSION}")
set (_libcompizconfig_package "LibCompizCompiz")

set (ALL_LINGUAS af ar bg bn bn_IN bs ca cs cy da de el en_GB en_US es eu et fi fr gl gu he hi hr hu id it ja ka km ko lo lt mk mr nb nl or pa pl pt pt_BR ro ru sk sl sr sv ta tr uk vi xh zh_CN zh_TW zu)
set (GETTEXT_PACKAGE libcompizconfig)

configure_file (
    "${CMAKE_SOURCE_DIR}/config.h.in"
    "${CMAKE_BINARY_DIR}/config.h"
    )

include_directories (
    "include"
    )

if (COMPIZ_PACKAGING_ENABLED)
    set (libdir ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}         CACHE PATH "libdir")
    set (includedir ${CMAKE_INSTALL_PREFIX}/include/compizconfig CACHE PATH "includedir")
    set (prefix ${CMAKE_INSTALL_PREFIX}                          CACHE PATH "prefix")
    set (exec_prefix ${CMAKE_INSTALL_PREFIX}/bin                 CACHE PATH "bindir")
else (COMPIZ_PACKAGING_ENABLED)
    set (libdir ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
    set (includedir ${CMAKE_INSTALL_PREFIX}/include/compizconfig)
    set (prefix ${CMAKE_INSTALL_PREFIX})
    set (exec_prefix ${CMAKE_INSTALL_PREFIX}/bin)
endif (COMPIZ_PACKAGING_ENABLED)

set (COMPIZ_SYSCONFDIR "/etc" CACHE PATH "/etc")

option (USE_PROTOBUF
	"Use Google Protocol Buffers library for faster XML loading"
	ON
	)

set (PROTOC_ERROR_MESSAGE
     "\nWARNING: You need to install Protocol Buffers to get faster program startup.\n"
     "Sources are available at http://code.google.com/p/protobuf/downloads/list\n"
     "Package names for Ubuntu/Debian: libprotobuf0, libprotobuf-dev, protobuf-compiler\n"
     "Package names for other distributions: protobuf, protobuf-devel\n"
     "Disabling protobuf.\n"
     )

set (LIBCOMPIZCONFIG_PROTOBUF
     protobuf)

if (USE_PROTOBUF)
    find_program (HAVE_PROTOC protoc)
    if (HAVE_PROTOC)
	if (USE_PROTOBUF)
	    pkg_check_modules (PROTOBUF protobuf)
	    if (PROTOBUF_FOUND)
	    else ()
		message (${PROTOC_ERROR_MESSAGE})
		set (USE_PROTOBUF
		     false
		     )
	    endif (PROTOBUF_FOUND)
	endif (USE_PROTOBUF)
    else ()
	message (${PROTOC_ERROR_MESSAGE})
	set (USE_PROTOBUF
	     false
	     )
    endif (HAVE_PROTOC)
endif (USE_PROTOBUF)

if (USE_PROTOBUF)
    set (HAVE_PROTOBUF TRUE)
endif (USE_PROTOBUF)

check_include_file ("sys/inotify.h"
		    HAVE_INOTIFY)

set (INOTIFY_WARNING_MESSAGE
     "NOTE\n
      ======\n
      Inotify header files not found. While this library might work \n
      without them, user experience is degraded as settings won't be\n
      applied instantly. We strongly suggest installing the inotify\n
      header files.\n")

if (HAVE_INOTIFY)
else ()
    message (${INOTIFY_WARNING_MESSAGE})
endif (HAVE_INOTIFY)

set (COMPIZCONFIG_LIBDIR ${libdir})

set (LIBCOMPIZCONFIG_REQUIRES
    x11
    compiz
    libxml-2.0
    libxslt
    )

if (HAVE_PROTOBUF)
    set (LIBCOMPIZCONFIG_REQUIRES
	 ${LIBCOMPIZCONFIG_REQUIRES}
	 protobuf)
endif ()

compiz_pkg_check_modules (LIBCOMPIZCONFIG REQUIRED ${LIBCOMPIZCONFIG_REQUIRES})

compiz_configure_file (
    ${CMAKE_CURRENT_SOURCE_DIR}/libcompizconfig.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/libcompizconfig.pc
)

install (
    FILES ${CMAKE_CURRENT_BINARY_DIR}/libcompizconfig.pc
    DESTINATION ${COMPIZ_DESTDIR}${libdir}/pkgconfig
)


add_subdirectory (config)
add_subdirectory (backend)
add_subdirectory (plugin)
add_subdirectory (src)
add_subdirectory (include)
add_subdirectory (cmake)

compiz_print_configure_header ("CompizConfig Library")
compiz_color_message ("\n${_escape}[4mOptional features:${_escape}[0m\n")

compiz_print_result_message ("protocol buffers" HAVE_PROTOBUF)
compiz_print_result_message ("file system change notifications" HAVE_INOTIFY)
compiz_print_plugin_stats ("${CMAKE_SOURCE_DIR}/plugin")
compiz_print_configure_footer ()

find_file (_find_compizconfig FindCompizConfig.cmake PATHS ${CMAKE_ROOT}/Modules ${ARGN})
if (NOT _find_compizconfig)
    compiz_color_message ("${_escape}[1;31mWARNING:${_escape}[0m")
    message ("\"FindCompiz.cmake\" file not found in cmake module directories.")
    message ("It should be installed to allow building of external compiz packages.")
    message ("Call \"sudo make findcompiz_install\" to install it.\n")
    compiz_print_configure_footer ()
endif (NOT _find_compizconfig)
    add_custom_target (
        findcompizconfig_install
	${CMAKE_COMMAND} -E make_directory ${COMPIZ_DESTDIR}${CMAKE_ROOT}/Modules &&
	${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/cmake/FindCompizConfig.cmake ${COMPIZ_DESTDIR}${CMAKE_ROOT}/Modules
    )

macro (add_uninstall)
	compiz_set(_compiz_uninstall_rule_created TRUE)

	set (_file "${CMAKE_BINARY_DIR}/cmake_uninstall.cmake")

	file (WRITE  ${_file} "if (NOT EXISTS \"${CMAKE_BINARY_DIR}/install_manifest.txt\")\n")
	file (APPEND ${_file} "  message (FATAL_ERROR \"Cannot find install manifest: \\\"${CMAKE_BINARY_DIR}/install_manifest.txt\\\"\")\n")
	file (APPEND ${_file} "endif (NOT EXISTS \"${CMAKE_BINARY_DIR}/install_manifest.txt\")\n\n")
	file (APPEND ${_file} "file (READ \"${CMAKE_BINARY_DIR}/install_manifest.txt\" files)\n")
	file (APPEND ${_file} "string (REGEX REPLACE \"\\n\" \";\" files \"\${files}\")\n")
	file (APPEND ${_file} "foreach (file \${files})\n")
	file (APPEND ${_file} "  message (STATUS \"Uninstalling \\\"\${file}\\\"\")\n")
	file (APPEND ${_file} "  if (EXISTS \"\${file}\")\n")
	file (APPEND ${_file} "    exec_program(\n")
	file (APPEND ${_file} "      \"${CMAKE_COMMAND}\" ARGS \"-E remove \\\"\${file}\\\"\"\n")
	file (APPEND ${_file} "      OUTPUT_VARIABLE rm_out\n")
	file (APPEND ${_file} "      RETURN_VALUE rm_retval\n")
	file (APPEND ${_file} "      )\n")
	file (APPEND ${_file} "    if (\"\${rm_retval}\" STREQUAL 0)\n")
	file (APPEND ${_file} "    else (\"\${rm_retval}\" STREQUAL 0)\n")
	file (APPEND ${_file} "      message (FATAL_ERROR \"Problem when removing \\\"\${file}\\\"\")\n")
	file (APPEND ${_file} "    endif (\"\${rm_retval}\" STREQUAL 0)\n")
	file (APPEND ${_file} "  else (EXISTS \"\${file}\")\n")
	file (APPEND ${_file} "    message (STATUS \"File \\\"\${file}\\\" does not exist.\")\n")
	file (APPEND ${_file} "  endif (EXISTS \"\${file}\")\n")
	file (APPEND ${_file} "endforeach (file)\n")

	add_custom_target(uninstall "${CMAKE_COMMAND}" -P "${CMAKE_BINARY_DIR}/cmake_uninstall.cmake")
endmacro ()

compiz_ensure_linkage ()
compiz_package_generation ("CompizConfig Library")
add_uninstall ()
compiz_add_git_dist ()
compiz_add_distcheck ()
compiz_add_release ()
compiz_add_release_signoff ()

=== backend/CMakeLists.txt ===
set (CMAKE_MODULE_PATH_ORIG ${CMAKE_MODULE_PATH})
set (LIBCOMPIZCONFIG_CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${LIBCOMPIZCONFIGZ_CMAKE_MODULE_PATH})

# Sorry for the kittens
include (${CMAKE_SOURCE_DIR}/cmake/LibCompizConfigCommon.cmake)

set (_COMPIZCONFIG_INTERNAL true)

compizconfig_backend (ini)

=== src/CMakeLists.txt ===
include_directories (
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${LIBCOMPIZCONFIG_INCLUDE_DIRS}
)

set (LIBCOMPIZCONFIG_FILES
    bindings.c
    ccs-private.h
    compiz.cpp
    config.c
    filewatch.c
    ini.c
    iniparser.c
    iniparser.h
    lists.c
    main.c
)

add_definitions (
    -DHAVE_CONFIG_H
    -DPLUGINDIR=\\\"${COMPIZ_PLUGINDIR}\\\"
    -DIMAGEDIR=\\\"${COMPIZ_IMAGEDIR}\\\"
    -DMETADATADIR=\\\"${COMPIZ_METADATADIR}\\\"
    -DSYSCONFDIR=\\\"${COMPIZ_SYSCONFDIR}\\\"
    -DDATADIR=\\\"${COMPIZ_DATADIR}\\\"
    -DLIBDIR=\\\"${COMPIZ_LIBDIR}\\\"
)

if (HAVE_PROTOBUF)
    exec_program (${HAVE_PROTOC} ${CMAKE_SOURCE_DIR}/src
		  ARGS "--cpp_out='.' compizconfig.proto")
    set (LIBCOMPIZCONFIG_FILES
	 ${LIBCOMPIZCONFIG_FILES}
	 compizconfig.pb.cc
	)
    add_definitions (
	    -DUSE_PROTOBUF
    )
endif (HAVE_PROTOBUF)

if (HAVE_INOTIFY)
    add_definitions (
	    -DHAVE_SYS_INOTIFY_H
    )
endif (HAVE_INOTIFY)

add_library (
    compizconfig SHARED
    ${LIBCOMPIZCONFIG_FILES}
)

set_target_properties (compizconfig PROPERTIES
    VERSION 0.0.0
    SOVERSION 0
)

link_directories (
    ${LIBCOMPIZCONFIG_LINK_DIRS}
)

target_link_libraries (
    compizconfig ${LIBCOMPIZCONFIG_LIBRARIES} m
)

set (COMPIZCONFIG_LIBS "")
foreach (_val ${LIBCOMPIZCONFIG_LDFLAGS})
    set (COMPIZCONFIG_LIBS "${COMPIZCONFIG_LIBS}${_val} ")
endforeach (_val ${LIBCOMPIZCONFIG_LDFLAGS})

set (COMPIZCONFIG_CFLAGS "")
foreach (_val ${LIBCOMPIZCONFIG_CFLAGS})
    set (COMPIZCONFIG_CFLAGS "${COMPIZCONFIG_CFLAGS}${_val} ")
endforeach (_val ${LIBCOMPIZCONFIG_CFLAGS})

install (
    TARGETS compizconfig
    DESTINATION ${COMPIZ_DESTDIR}${libdir}
)

=== debian/changelog ===
libcompizconfig (0.9.7.0~bzr428-0ubuntu6) precise-proposed; urgency=low

  * debian/control:
    - bump compiz-dev build-dep for ABI break

 -- Didier Roche <didrocks@ubuntu.com>  Tue, 20 Mar 2012 16:00:19 +0100

libcompizconfig (0.9.7.0~bzr428-0ubuntu5) precise; urgency=low

  * debian/control:
    - bump compiz-dev build-dep for ABI break

 -- Didier Roche <didrocks@ubuntu.com>  Tue, 20 Mar 2012 15:35:08 +0100

libcompizconfig (0.9.7.0~bzr428-0ubuntu4) precise; urgency=low

  * debian/control:
    - bump compiz-dev build-dep for ABI break

 -- Didier Roche <didrocks@ubuntu.com>  Mon, 12 Mar 2012 10:24:49 +0100

libcompizconfig (0.9.7.0~bzr428-0ubuntu3) precise; urgency=low

  * debian/patches/02_primary_is_ctrl.patch:
    - teach to compiz that gtk "primary" is control to enable
      picking right keys from ccsm and g-c-c

 -- Didier Roche <didrocks@ubuntu.com>  Tue, 21 Feb 2012 15:47:36 +0100

libcompizconfig (0.9.7.0~bzr428-0ubuntu2) precise; urgency=low

  * debian/control:
    - build-dep on latest compiz-dev (ABI breakage)

 -- Didier Roche <didrocks@ubuntu.com>  Thu, 16 Feb 2012 15:12:59 +0100

libcompizconfig (0.9.7.0~bzr428-0ubuntu1) precise; urgency=low

  * New upstream snapshot
  * debian/control:
    - build-dep on latest compiz-dev (ABI break)
  * debian/rules:
    - pick new abiversion file
  * debian/patches/fix_configuration_upgrade.patch,
    debian/patches/use_gconf_still.patch:
    - remove, in upstream tarball
  * debian/patches/01_add_unity_profile.patch:
    - readded as was previously in upstream tarball, but reverted

 -- Didier Roche <didrocks@ubuntu.com>  Mon, 13 Feb 2012 15:30:01 +0100

=== debian/control ===
Source: libcompizconfig
Section: libs
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 7.0.50~),
               cmake,
               compiz-dev (>= 1:0.9.7.2),
               pkg-config,
               intltool,
               libxml2-dev,
               libxslt1-dev,
               libprotobuf-dev,
               protobuf-compiler,
               libxslt1-dev,
               xsltproc,
               libboost1.46-dev,
               libboost-serialization1.46-dev,
Standards-Version: 3.8.0
Vcs-Bzr: http://bazaar.launchpad.net/~compiz/libcompizconfig/ubuntu

Package: libcompizconfig0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 
 compiz-core, compiz-core-abiversion-${coreabiversion}
Breaks: compiz-core (<< 1:0.9.2.1+glibmainloop3),
        compizconfig-backend-gconf (<< 0.9.5.92)
Description: Settings library for plugins - OpenCompositing Project
 The OpenCompositing Project brings 3D desktop visual effects that improve
 usability of the X Window System and provide increased productivity
 through plugins and themes contributed by the community giving a
 rich desktop experience.
 .
 This package contains the library for plugins to configure settings.

Package: libcompizconfig0-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, 
 libcompizconfig0 (= ${binary:Version}), compiz-dev
Description: Development file for plugin settings - OpenCompositing Project
 The OpenCompositing Project brings 3D desktop visual effects that improve
 usability of the X Window System and provide increased productivity
 through plugins and themes contributed by the community giving a
 rich desktop experience.
 .
 This package contains the headers and development files needed to
 build plugins with settings support.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CORE_ABIVERSION := $(shell sed -rn 's/^\#define[[:space:]]+CORE_ABIVERSION[[:space:]]+//p' /usr/include/compiz/core/abiversion.h )


override_dh_auto_configure:
	dh_auto_configure -- -DCOMPIZ_BUILD_WITH_RPATH=FALSE -DCOMPIZ_PACKAGING_ENABLED=TRUE -DCOMPIZ_PLUGIN_INSTALL_TYPE=package -DUSE_GSETTINGS=OFF -DCOMPIZ_DISABLE_GS_SCHEMAS_INSTALL=ON

override_dh_gencontrol:
	dh_gencontrol -- -Vcoreabiversion=$(CORE_ABIVERSION)

override_dh_install:
	# cmake findcompiz_install use COMPIZ_DESTDIR and using COMPIZ_DESTDIR
	# and DESTDIR together is completely broken upstream
	# So, doing the same in debian/rules to find a way to install things in the
	# right place, sorry for the kittens
	cmake_dir=`cmake --system-information 2> /dev/null | grep "^CMAKE_ROOT " | sed -e 's/.*"\(.*\)"/\1/'` && \
    mkdir -p debian/tmp$${cmake_dir}/Modules && cp cmake/FindCompizConfig.cmake debian/tmp$${cmake_dir}/Modules

	dh_install --fail-missing

%:
	dh $@
